searchData={"items":[{"type":"module","title":"Baby","doc":"Bushbaby Automated Bamboo Yields\n\nReference `bushbaby` protocol node\n\n#","ref":"Baby.html"},{"type":"module","title":"Configuration - Baby","doc":"`spool_dir`: The path to the `Baobab` bamboo store spool\n`clumps`: List of per-clump keyword configurations\n    - `id`: a binary `clump_id`\n    - `controlling_identity`: a `Baobab.Identity` by which this peer will be known\n    - `port`: an integer port to which to bind\n    - `cryouts`: list of keyword configurations for periodic peer replication\n        - `host`: peer host address\n        - `port`: peer port\n        - `period`: `{integer quantity, atom unit}` ({17, :minute})","ref":"Baby.html#module-configuration"},{"type":"function","title":"Baby.are_connected?/1","doc":"Determine if there is an active connection on an array of `{host, port}`\n\nReturns a map with the tuples as keys and a boolean result","ref":"Baby.html#are_connected?/1"},{"type":"function","title":"Baby.connect/3","doc":"Connect to a remote hort and port\n\nKeyword id_options relative to the configured `Baobab` store\n- clump_id\n- identity","ref":"Baby.html#connect/3"},{"type":"function","title":"Baby.is_connected?/1","doc":"Determine if there is an active connection on a given `{host, port}`","ref":"Baby.html#is_connected?/1"},{"type":"module","title":"Baby.Application","doc":"By design the `Baby` server does not start automatically.\n\nTo use the `:baby` configuration, it may be started via:\n\n```\nBaby.Application.start(:normal)\n```\n\nOne may also craft a custom configuration to be supplied at runtime:\n\n```\nconfig = [spool_dir: \"~/.special_bamboo\"]\nBaby.Application.start(:normal, config)\n```","ref":"Baby.Application.html"},{"type":"function","title":"Baby.Application.child_spec/1","doc":"A usable child specification for starting under a supervision tree","ref":"Baby.Application.html#child_spec/1"},{"type":"module","title":"Baby.Connection","doc":"State machine connection handler","ref":"Baby.Connection.html"},{"type":"function","title":"Baby.Connection.child_spec/1","doc":"","ref":"Baby.Connection.html#child_spec/1"},{"type":"function","title":"Baby.Connection.start_link/1","doc":"","ref":"Baby.Connection.html#start_link/1"},{"type":"module","title":"Baby.Connection.Registry","doc":"A process registry for `Baby.Connection`\n\nFor maximum utility, name should be of the form:\n`{host, port}`\nwhere host is an internet address tuple and port is an integer","ref":"Baby.Connection.Registry.html"},{"type":"function","title":"Baby.Connection.Registry.active/0","doc":"Return a list of all named connections","ref":"Baby.Connection.Registry.html#active/0"},{"type":"function","title":"Baby.Connection.Registry.active?/1","doc":"Check if a named connection is active","ref":"Baby.Connection.Registry.html#active?/1"},{"type":"function","title":"Baby.Connection.Registry.broadcast/2","doc":"Send a message to all registered connections\n\nCan include a list of names or pids to exclude","ref":"Baby.Connection.Registry.html#broadcast/2"},{"type":"function","title":"Baby.Connection.Registry.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Baby.Connection.Registry.html#child_spec/1"},{"type":"function","title":"Baby.Connection.Registry.init/1","doc":"","ref":"Baby.Connection.Registry.html#init/1"},{"type":"function","title":"Baby.Connection.Registry.register_name/2","doc":"","ref":"Baby.Connection.Registry.html#register_name/2"},{"type":"function","title":"Baby.Connection.Registry.send/2","doc":"Send a message to a named connection","ref":"Baby.Connection.Registry.html#send/2"},{"type":"function","title":"Baby.Connection.Registry.start_link/1","doc":"","ref":"Baby.Connection.Registry.html#start_link/1"},{"type":"function","title":"Baby.Connection.Registry.unregister_name/1","doc":"","ref":"Baby.Connection.Registry.html#unregister_name/1"},{"type":"function","title":"Baby.Connection.Registry.whereis_name/1","doc":"","ref":"Baby.Connection.Registry.html#whereis_name/1"},{"type":"module","title":"Baby.Log.Acceptor","doc":"Disk queue for incoming bamboo data\n\nThe writing process, with its included verification, is much\nslower than the reading process.  This means that peers are\nsending data much faster than we can store it.\n\nAs such, we have this level of indirection which gets the\ndata out of memory (including process mailboxes) and on to\ndisk.  We may even be able to recover old data upon restart","ref":"Baby.Log.Acceptor.html"},{"type":"function","title":"Baby.Log.Acceptor.ack_job/1","doc":"","ref":"Baby.Log.Acceptor.html#ack_job/1"},{"type":"function","title":"Baby.Log.Acceptor.add_job/2","doc":"","ref":"Baby.Log.Acceptor.html#add_job/2"},{"type":"function","title":"Baby.Log.Acceptor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Baby.Log.Acceptor.html#child_spec/1"},{"type":"function","title":"Baby.Log.Acceptor.init/1","doc":"","ref":"Baby.Log.Acceptor.html#init/1"},{"type":"function","title":"Baby.Log.Acceptor.next_job/0","doc":"","ref":"Baby.Log.Acceptor.html#next_job/0"},{"type":"function","title":"Baby.Log.Acceptor.start_link/1","doc":"","ref":"Baby.Log.Acceptor.html#start_link/1"},{"type":"module","title":"Baby.Log.Writer","doc":"Stand alone writer for the `Baobab` log store","ref":"Baby.Log.Writer.html"},{"type":"function","title":"Baby.Log.Writer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Baby.Log.Writer.html#child_spec/1"},{"type":"function","title":"Baby.Log.Writer.handle_continue/2","doc":"","ref":"Baby.Log.Writer.html#handle_continue/2"},{"type":"function","title":"Baby.Log.Writer.init/1","doc":"","ref":"Baby.Log.Writer.html#init/1"},{"type":"function","title":"Baby.Log.Writer.start_link/1","doc":"","ref":"Baby.Log.Writer.html#start_link/1"},{"type":"module","title":"Baby.Monitor","doc":"Cutely and unhelpfully named.\nA GenServer managing periodic `cryout` activity","ref":"Baby.Monitor.html"},{"type":"function","title":"Baby.Monitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Baby.Monitor.html#child_spec/1"},{"type":"function","title":"Baby.Monitor.start_link/1","doc":"","ref":"Baby.Monitor.html#start_link/1"},{"type":"module","title":"Baby.Protocol","doc":"Protocol implementation","ref":"Baby.Protocol.html"},{"type":"function","title":"Baby.Protocol.definition/0","doc":"A map of the protocol definitions","ref":"Baby.Protocol.html#definition/0"},{"type":"function","title":"Baby.Protocol.inbound/3","doc":"Handle inbound data of the provided message type based on the supplied connection state","ref":"Baby.Protocol.html#inbound/3"},{"type":"function","title":"Baby.Protocol.msglookup/1","doc":"A dual-way map between message types and semantic protocol atoms","ref":"Baby.Protocol.html#msglookup/1"},{"type":"function","title":"Baby.Protocol.outbound/2","doc":"Craft and enqueue an outbound messagei or the provided type from the current connection state","ref":"Baby.Protocol.html#outbound/2"},{"type":"function","title":"Baby.Protocol.presort/2","doc":"","ref":"Baby.Protocol.html#presort/2"},{"type":"function","title":"Baby.Protocol.unpack_nonce_box/2","doc":"","ref":"Baby.Protocol.html#unpack_nonce_box/2"},{"type":"module","title":"Baby.Util","doc":"Utility functions for use across the codebase","ref":"Baby.Util.html"},{"type":"function","title":"Baby.Util.connection_log/4","doc":"Standardised connection activity logging for the supplied state\n  `dir`: `:in`, `:out`, `:both`\n  `msg`: a protocol message type atom\n  `level`: log lvel atom (default: `:debug`)","ref":"Baby.Util.html#connection_log/4"},{"type":"function","title":"Baby.Util.host_to_ip/1","doc":"A simple wrapper to convert a host binary into an IP tuple","ref":"Baby.Util.html#host_to_ip/1"},{"type":"function","title":"Baby.Util.log_fatal/2","doc":"Logging of fatal errors takes connection info and the error\n\nReturns `:error`","ref":"Baby.Util.html#log_fatal/2"},{"type":"function","title":"Baby.Util.period_to_ms/1","doc":"Convert a `{count, unit}` period into a number of milliseconds","ref":"Baby.Util.html#period_to_ms/1"},{"type":"function","title":"Examples - Baby.Util.period_to_ms/1","doc":"iex> Baby.Util.period_to_ms({1, :hour})\n     3_600_000\n\n\n     iex> Baby.Util.period_to_ms({17, :minute})\n     1_020_000","ref":"Baby.Util.html#period_to_ms/1-examples"},{"type":"function","title":"Baby.Util.range_points/1","doc":"Returns tuples of the endpoints of the widest continuous ranges\nin a list of integers\n\n    iex> Baby.Util.range_points([8, 2, 5, 4, 3, 10, 11, 16, 17])\n    [{2, 5}, {8, 8}, {10, 11}, {16, 17}]\n\n    iex> Baby.Util.range_points([127])\n    [{127, 127}]\n\n    iex> Baby.Util.range_points([])\n    []","ref":"Baby.Util.html#range_points/1"}],"content_type":"text/markdown"}